
/**
 * @imports
 */
import {Reflex} from '@web-native-js/chtml';
import _each from '@web-native-js/commons/obj/each.js';
import _remove from '@web-native-js/commons/arr/remove.js';
import _pushUnique from '@web-native-js/commons/arr/pushUnique.js';
import _isArray from '@web-native-js/commons/js/isArray.js';

/**
 * ---------------------------
 * The List class
 * ---------------------------
 */
			
export default class {

	/**
	 * Constitutes the this context for subclasses.
	 * Adds items to the collection.
	 *
	 * @param object				items
	 * @param object				params
	 *
	 * @return void
	 */
	constructor(items = {}, params = {}) {
		this.params = params;
		if (!this.params.itemsOffset) {
			throw new Error('"this.params.itemsOffset" cannot be undefined!');
		}
		_each(items, (key, value) => {
			Reflex.set(this, key, value);
		});
		// Record sates
		Reflex.set(this, 'stats', {});
		(params.takeStats || []).forEach(stateName => {
			// Initialize the specific collation
			this.stats[stateName] = [];
			// Observe the sate
			var pathToState = this.params.itemsOffset + '..' + stateName;
			Reflex.observe(this, pathToState, (state, _state, e) => {
				if (state === true) {
					// Add to a collection?
					_pushUnique(this.stats[stateName], e.originatingTarget);
					Reflex.set(this.stats, stateName, this.stats[stateName]);
				} else if (state === false) {
					// Remove from a collection?
					_remove(this.stats[stateName], e.originatingTarget);
					Reflex.set(this.stats, stateName, this.stats[stateName]);
				}
			});
		});
	}

	/**
	 * Returns the list of items cast to array.
	 *
	 * @return array
	 */
	getItemsArray() {
		var items = this[this.params.itemsOffset];
		return _isArray(items) ? items : Object.values(items)
	}

	/**
	 * Advances the list's selectedness to a item.
	 *
	 * @return object
	 */
	filter() {
	}

	/**
	 * Advances the list's selectedness to a item.
	 *
	 * @return object
	 */
	sort() {
	}
};