
/**
 * @imports
 */
import {Reflex} from '@web-native-js/chtml';

/**
 * ---------------------------
 * The Frame class
 * ---------------------------
 *
 * This class represents a given route and manages
 * its sub-route.
 */
			
export default class {

	/**
	 * Controls the Frame's active state.
	 *
	 * @param bool				state
	 *
	 * @return Event
	 */
	setActiveState(state = true) {
		var e = Reflex.set(this, 'active', !state ? 'deactivating' : 'activating', true/*returnEvent*/);
		if (e.promises) {
			e.promises.then(() => {
				Reflex.set(this, 'active', state, true/*returnEvent*/);
			});
			return e;
		} else {
			return Reflex.set(this, 'active', state, true/*returnEvent*/);
		}
	}
};