
/**
 * @imports
 */
import _arrFrom from '@web-native-js/commons/arr/from.js';
import _copy from '@web-native-js/commons/obj/copy.js';
import _copyPlain from '@web-native-js/commons/obj/copyPlain.js';
import XObserver from './XObserver.js';

/**
 * ---------------------------
 * Represents an IntersectionObserver
 * that publishes entries to state.
 * ---------------------------
 */

export default class extends XObserver {
	
	/**
	 * @inheritdoc
	 */
	constructor(targets = [], options = {}) {
		super(targets, options);
		this.$.observer = new IntersectionObserver(entries => {
			entries.forEach(entry => {
				this._publish(entry);
				if (options.once) {
					this.$.observer.unobserve(entry.target);
				}
			});
		}, _copy(this.$.params, ['root', 'rootMargin', 'threshold']));
		_arrFrom(targets, false/*castObject*/).forEach(target => this.$.observer.observe(target));
	}
};
