
/**
 * @imports
 */
import _arrFrom from '@web-native-js/commons/arr/from.js';
import _copy from '@web-native-js/commons/obj/copy.js';
import ProximityObserver from '../../chtml/ui/ProximityObserver.js';
import XObserver from './XObserver.js';

/**
 * ---------------------------
 * Represents a ProximityObserver
 * that publishes entries to state.
 * ---------------------------
 */

export default class extends XObserver {
	
	/**
	 * @inheritdoc
	 */
	constructor(targets = [], params = {}) {
		super(targets, params);
		this.$.observer = new ProximityObserver(entries => {
			entries.forEach(entry => {
				this._publish(entry);
				if (this.$.params.once) {
					this.$.observer.unobserve(entry.target);
				}
			});
		}, _copy(this.$.params, ['root', 'rootMargin', 'axis']));
		_arrFrom(targets, false/*castObject*/).forEach(target => this.$.observer.observe(target));
	}
};
