
/**
 * @imports
 */
import _arrFrom from '@web-native-js/commons/arr/from.js';
import cssReadAsync from '../../chtml/css/readAsync.js';
import XObserver from './XObserver.js';

/**
 * ---------------------------
 * Represents a ResizeObserver
 * that publishes entries to state.
 * ---------------------------
 */

export default class extends XObserver {
	
	/**
	 * @inheritdoc
	 */
	constructor(targets = [], options = {}) {
		super(targets, options);
		this.$.observer = new ResizeObserver(entries => {
			entries.forEach(entry => {
				if (!entry.contentBoxSize) {
					cssReadAsync(entry.target, ['writing-mode']).then(values => {
						var inVerticalWritingMode = ['vertical-lr', 'vertical-rl'].contains(values['writing-mode']);
						entry.contentBoxSize = {};
						Object.defineProperty(entry.contentBoxSize, 'inlineSize', {value:inVerticalWritingMode ? entry.contentRect.height : entry.contentRect.width});
						Object.defineProperty(entry.contentBoxSize, 'blockSize', {value:inVerticalWritingMode ? entry.contentRect.width : entry.contentRect.height});
						entry.borderBoxSize = {};
						Object.defineProperty(entry.borderBoxSize, entry.contentBoxSize.inlineSize);
						Object.defineProperty(entry.borderBoxSize, entry.contentBoxSize.blockSize);
						this._publish(entry);
					});
				} else {
					this._publish(entry);
				}
			});
		});
		_arrFrom(targets, false/*castObject*/).forEach(target => this.$.observer.observe(target));
	}
};
