
/**
 * @imports
 */
import _isString from '@web-native-js/commons/js/isString.js';
import _isObject from '@web-native-js/commons/js/isObject.js';
import cssRead from './read.js';
import cssWrite from './write.js';

/**
 * The cssRead() and cssWrite() function in one signature.
 *
 * @param HTMLElement		el
 * @param array				...args
 *
 * @return mixed
 */
export default function(el, ...args) {
	if ((args.length > 1 && _isString(args[0])) || _isObject(args[0])) {
		return cssWrite(el, ...args);
	}
	return cssRead(el, ...args);
};
