
/**
 * @imports
 */
import _isString from '@web-native-js/commons/js/isString.js';
import _isObject from '@web-native-js/commons/js/isObject.js';
import cssReadAsync from './readAsync.js';
import cssWriteAsync from './writeAsync.js';

/**
 * The async type of css().
 *
 * @see css()
 *
 * @return Promise
 */
export default function(el, ...args) {
	if ((args.length > 1 && _isString(args[0])) || _isObject(args[0])) {
		return cssWriteAsync(el, ...args);
	}
	return cssReadAsync(el, ...args);
};
