
/**
 * @imports
 */
import cssReadInline from './readInline.js';
import cssWriteAsync from './writeAsync.js';
import Transaction from '../Transaction.js';

/**
 * Establishes a CSS operatiom that can be rolledback without altering similar operation by other code.
 * If a callback is provided, it synces the entire operation with Reflow's normal read/write cycles.
 *
 * @param HTMLElement			el 
 * @param string|array			props
 *
 * @return Transaction
 */
export default function(el, props) {
	return new Transaction(el, props, (el, props) => {
		return cssReadInline(el, props);
	}, (el, data) => {
		return cssWriteAsync(el, data);
	});
};
