
/**
 * @imports
 */
import _fromCamel from '@web-native-js/commons/str/fromCamel.js';
import _toCamel from '@web-native-js/commons/str/toCamel.js';
import vendorPrefix from './vendorPrefix.js';

/**
 * Returns the vendor-specific css property if supported. NULL if not.
 *
 * @param string 	prop
 *
 * @return string|NULL
 */
export default function(prop) {
	var camelCasedProp = _toCamel(prop, true);
	if (vendorPrefix.api + camelCasedProp in document.body.style) {
		return vendorPrefix.css + _fromCamel(prop, '-');
	}
};
