
/**
 * @imports
 */
import _isFunction from '@web-native-js/commons/js/isFunction.js';
import cssWrite from './write.js';
import Reflow from '../Reflow.js';

/**
 * The async type of cssWrite().
 *
 * @see cssWrite()
 *
 * @return Promise
 */
export default function(el, nameOrProps, val = null) {
	return Reflow.onwrite((resolve, reject) => {
		try {
			resolve(_isFunction(nameOrProps) ? nameOrProps(el) : cssWrite(el, nameOrProps, val));
		} catch(e) {
			reject(e);
		}
	}, true/*withPromise*/);
};
