
/**
 * Observes changes in attributes of the given element.
 *
 * @param HTMLElement				el
 * @param function					callback
 * @param array						filter
 *
 * @return MutationObserver
 */
export default function(el, callback, filter = []) {
	var observer = new MutationObserver(mutations => {
		mutations.forEach(m => {
			callback(m);
		});
	});
	var params = {attributes:true, attributeOldValue:true};
	if (filter) {
		params.attributeFilter = filter;
	}
	observer.observe(el, params);
	return observer;
};
