
/**
 * @imports
 */
import _isString from '@web-native-js/commons/js/isString.js';
import domFind from './find.js';

/**
 * Creates a DOM element
 * from any of markup, selector, HTMLElement.
 *
 * @param mixed 				input
 *
 * @return bool
 */
export default function(input) {
	if (_isString(input)) {
		var el;
		if (input.trim().startsWith('<')) {
			// Create a node from markup
			var temp = document.createElement('div');
			temp.innerHtml = input;
			el = temp.firstChild;
		} else {
			el = domFind(input);
		}
		return el;
	}
	return input;
};
