
/**
 * Returns all, only text nodes.
 *
 * @param DOMElement 			el
 *
 * @return array
 */
export default function(el) {
	// Filter
	var rejectScriptTextFilter = {
		acceptNode: function(node) {
			if (node.parentNode.nodeName !== 'SCRIPT') {
				return NodeFilter.FILTER_ACCEPT;
			}
		}
	};
	// Walker
	var walker = document.createTreeWalker(el, NodeFilter.SHOW_TEXT, rejectScriptTextFilter, false);
	var node;
	var textNodes = [];
	while(node = walker.nextNode()) {
		textNodes.push(node.nodeValue);
	}
	return textNodes;
};
