
/**
 * @imports
 */
import ListenerBase from './ListenerBase.js';
import Listener from './Listener.js';

/**
 * Binds listeners to an element's event controller.
 *
 * @param array|object 			object
 * @param string		 		type
 * @param function		 		callback
 *
 * @return object
 */
export default function(object, type, callback) {
	var firebase;
	if (!(firebase = ListenerBase.getForTarget(object))) {
		firebase = ListenerBase.createForTarget(object);
	}
	return firebase.addFireable(new Listener(callback, {type}));
};