
/**
 * @imports
 */
import _merge from '@web-native-js/commons/obj/merge.js';

/**
 * Returns distances in x, y, and z between the centers of two rects.
 *
 * @param object		rect1
 * @param object		rect2
 * @param bool			withAngle
 *
 * @return object
 */
export default function(rect1, rect2, withAngle = false) {
	var $delta = {};
	$delta.x = (rect2.left + (rect2.width / 2)) - (rect1.left + (rect1.width / 2));
	$delta.y = (rect2.top + (rect2.height / 2)) - (rect1.top + (rect1.height / 2));
	$delta.z = Math.sqrt(Math.pow($delta.x, 2) + Math.pow($delta.y, 2));
	if (withAngle) {
		$delta = _merge($delta, deltaAngle($delta));
	}
	return $delta;
};
