
/**
 * @imports
 */
import _isNumeric from '@web-native-js/commons/js/isNumeric.js';

/**
 * Returns distances in x, y, and z between the centers of two rects.
 *
 * @param object		delta
 *
 * @return object
 */
export default function(delta) {
	if (_isNumeric(delta.y) && _isNumeric(delta.x)) {
		var angleOfElevation = Math.atan(delta.y/delta.x);
	} else if (_isNumeric(delta.x) && _isNumeric(delta.z)) {
		var angleOfElevation = Math.acos(delta.x/delta.z);
	} else if (_isNumeric(delta.y) && _isNumeric(delta.z)) {
		var angleOfElevation = Math.asin(delta.y/delta.z);
	}
	var angleOfDepression = 180 - 90 - angleOfElevation;
	return {
		angle:angleOfElevation, 
		angle2:angleOfDepression, 
		isHorizontal:angleOfElevation < 45, 
		isVertical:angleOfDepression < 45,
	};
};
