
/**
 * @imports
 */
import delta from './delta.js';

/**
 * Returns coordinates of the intersection between two rects.
 *
 * @param object		rect1
 * @param object		rect2
 *
 * @return object
 */
export default function(rect1, rect2) {
	var $intersection = {
		left: rect1.left - rect2.left,
		top: rect1.top - rect2.top,
		right: (rect2.left + rect2.width) - (rect1.left + rect1.width),
		bottom: (rect2.top + rect2.height) - (rect1.top + rect1.height),
	};
	// More offsets
	var leftline = Math.max(rect1.left, rect2.left);
	var rightline = Math.min(rect1.left + rect1.width, rect2.left + rect2.width);
	var topline = Math.max(rect1.top, rect2.top);
	var bottomline = Math.min(rect1.top + rect1.height, rect2.top + rect2.height);
	$intersection.width = rightline > leftline ? rightline - leftline : 0;
	$intersection.height = bottomline > topline ? bottomline - topline : 0;
	// The raw values
	$intersection.rect1 = rect1;
	$intersection.rect2 = rect2;
	$intersection.delta = delta(rect1, rect2);
	return $intersection;
};
