
/**
 * @imports
 */
import _arrFrom from '@web-native-js/commons/arr/from.js';
import rect from './rect.js';

/**
 * Returns an object containing the element's left/top.
 *
 * @param DOMElement		el 
 * @param object			axis 
 * @param string|bool		offsetOrigin 
 *
 * @return object
 */
export default function(el, axis, origin = null) {
	var $offsets = rect(el, false, origin);
	var axes = axis ? _arrFrom(axis) : ['x', 'y'];
	if (!axes.includes('x')) {
		delete $offsets.left;
	}
	if (!axes.includes('y')) {
		delete $offsets.top;
	}
	return $offsets;
};
