
/**
 * @imports
 */
import cssRead from '../Css/read.js';
import intersection from './intersection.js';
import rect from './rect.js';

/**
 * Gets the element's left,top,bottom,right values
 * with "auto"s resolved.
 *
 * @param HTMLElement			el 
 * @param array					anchors 
 *
 * @return object
 */
export default function(el, anchors = ['left', 'top', 'right', 'bottom']) {
	var inverses = {right:'left', left:'right', bottom:'top', top:'bottom'};
	var currentOffsets = cssRead(el, anchors.concat('position'));
	var intersectionWithAnchor = null;
	anchors.forEach(name => {
		if (currentOffsets[name] === 'auto') {
			// Get what anchor value would be...
			// on current position type
			if (currentOffsets.position === 'relative') {
				currentOffsets[name] = - parseFloat(currentOffsets[inverses[name]]);
			} else if (currentOffsets.position === 'fixed') {
				intersectionWithAnchor = intersectionWithAnchor || intersection(rect(el), rect(window));
				currentOffsets[name] = intersectionWithAnchor[name];
			} else if (currentOffsets.position === 'absolute') {
				intersectionWithAnchor = intersectionWithAnchor || intersection(rect(el), rect(el.offsetParent));
				currentOffsets[name] = intersectionWithAnchor[name];
			}
		} else {
			currentOffsets[name] = parseFloat(currentOffsets[name]);
		}
	});
	delete currentOffsets.position;
	return currentOffsets;
};
