
/**
 * Gets an element's nearest scrollable parent.
 *
 * @param DOMNode		el
 *
 * @return jQuery
 */
export default function(el) {
	var style = window.getComputedStyle(el);
	var excludeStaticParent = style.position === 'absolute';
	var overflowRegex = false/*includeHidden*/ ? /(auto|scroll|hidden)/ : /(auto|scroll)/;
	if (style.position !== 'fixed') {
		for (var parent = el; (parent = parent.parentElement);) {
			style = window.getComputedStyle(parent);
			if (excludeStaticParent && style.position === 'static') {
				continue;
			}
			if (overflowRegex.test(style.overflow + style.overflowY + style.overflowX)) {
				return parent;
			}
		}
	}
	return document.body;
};
