
/**
 * @imports
 */
import _arrFrom from '@web-native-js/commons/arr/from.js';
import rect from './rect.js';

/**
 * Returns an object containing the element's width or height or both.
 *
 * @param DOMElement		el 
 * @param object			axis 
 *
 * @return object
 */
export default function(el, axis) {
	var $size = rect(el, true, false);
	var axes = axis ? _arrFrom(axis) : ['x', 'y'];
	if (!axes.includes('x')) {
		delete $size.width;
	}
	if (!axes.includes('y')) {
		delete $size.height;
	}
	return $size;
};
