
/**
 * @imports
 */
import delta from './delta.js';

/**
 * Returns coordinates of two rects as one.
 *
 * @param object		rect1
 * @param object		rect2
 *
 * @return object
 */
export default function(rect1, rect2) {
	var $union = {
		left: Math.min(rect1.left, rect2.left),
		top: Math.min(rect1.top, rect2.top),
		right: Math.max((rect1.left + rect1.width), (rect2.left + rect2.width)),
		bottom: Math.max((rect1.top + rect1.height), (rect2.top + rect2.height)),
	};
	// More offsets
	$union.width = $union.right - $union.left;
	$union.height = $union.bottom - $union.top;
	// The raw values
	$union.rect1 = rect1;
	$union.rect2 = rect2;
	$union.delta = delta(rect1, rect2);
	return $union;
};
