
/**
 * @imports
 */
import _arrFrom from '@web-native-js/commons/arr/from.js';
import cssRead from '../Css/read.js';

/**
 * Returns the heighest z-index attained by any of its descendants,
 * starting from its stacking context.
 *
 * @param DOMElement		el 
 *
 * @return int
 */
export default function(el) {
	var zIndex = 0;
	_arrFrom(el.children).forEach((el, i) => {
		zIndex = Math.max(zIndex, parseInt(cssRead(el, 'z-index')) || 0);
	});
	return zIndex;
};
